function [rate]=DisPLRC(Jtest,Jtrain,class,lpara)
% % % % % %  PLRC
% % % %    Solver type (lpara): 
% % % % ln--NN,  l2set--set-based-l2

if nargin < 4
    lpara = 'l2set';
end

[temr,trainallnum]=size(Jtrain);
[temr,testallnum]=size(Jtest);
trainsample=ceil(trainallnum/class);
testsample=ceil(testallnum/class);
pairsample=trainsample;

scorearr=zeros(1,class);
for ki=1:class
    disarr=zeros(1,class);
    test_tem=Jtest(:,((ki-1)*testsample+1):(ki*testsample));
    Xmean=mean(test_tem,2);
    test_tem2=test_tem(:,1:testsample)-Xmean*ones(1,testsample);
        
%     Ymeanall=mean(Jtrain,2);
%     train_tem2_all=Jtrain-Ymeanall*ones(1,trainallnum);
%     test_train_tem2_all=[train_tem2_all test_tem2];
%     XmeanYmeanall=Xmean-Ymeanall;
    switch lpara
% % % %    Solver type (lpara): 
% % % % ln--NN,  l2set--set-based-l2
       
        case 'ln'
            coef=ones(trainallnum,1);
        case 'l2set'
            Ymeanall=mean(Jtrain,2);
            train_tem2_all=Jtrain-Ymeanall*ones(1,trainallnum);
            test_train_tem2_all=[train_tem2_all test_tem2];
            XmeanYmeanall=Xmean-Ymeanall;

            coef=inv(test_train_tem2_all'*test_train_tem2_all+0.01*eye(trainallnum+testsample))*test_train_tem2_all'*XmeanYmeanall;
       
    end
%     
    
    
    seldis=zeros(1,size(Jtrain,2));
    for kt=1:size(Jtrain,2)
        seldis(kt)=norm(Xmean-Jtrain(:,kt)*coef(kt));
    end
    
    for kj=1:class
        train_tem=Jtrain(:,((kj-1)*trainsample+1):(kj*trainsample));
        Jtrainremoveone=Jtrain;
        seldis_tem=seldis;
        Jtrainremoveone(:,((kj-1)*trainsample+1):(kj*trainsample))=[];
        seldis_tem(((kj-1)*trainsample+1):(kj*trainsample))=[];
        [~,labsel]=sort(seldis_tem,'ascend');
        train_tem_pair=Jtrainremoveone(:,labsel(1:pairsample));
        
        Ymean=mean(train_tem,2);
        train_tem2=train_tem(:,1:trainsample)-Ymean*ones(1,trainsample);        
        test_train_tem2=[test_tem2 train_tem2];
        XmeanYmean=Xmean-Ymean;
        dtem=DisLRC(XmeanYmean,test_train_tem2);
        
        Ymean_pair=mean(train_tem_pair,2);
        train_tem_pair2=train_tem_pair(:,1:pairsample)-Ymean_pair*ones(1,pairsample);        
        test_train_tem_pair2=[test_tem2 train_tem_pair2];
        XmeanYmean_pair=Xmean-Ymean_pair;
        dtem_pair=DisLRC(XmeanYmean_pair,test_train_tem_pair2);
        
        disarr(kj)=dtem/dtem_pair;
    end

        
    indextem=find(disarr==min(disarr));
    if ~isempty(indextem)
        if indextem(1)==ki
            scorearr(ki)=1;
        end
    end
end

rate=sum(scorearr)/length(scorearr);